﻿/*
 * Crée par SharpDevelop.
 * Utilisateur: johann
 * Date: 01/10/2012
 * Heure: 15:46
 * 
 * Pour changer ce modèle utiliser Outils | Options | Codage | Editer les en-têtes standards.
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using SpringCardNFC;
using Be.Windows.Forms;

namespace SpringCardApplication
{
	/// <summary>
	/// Description of NdefDisplayForm.
	/// </summary>
	public partial class NdefDisplayForm : Form
	{
		public NdefDisplayForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		public void SetNdef(Ndef ndef)
		{
			/* Display the NDEF as raw data in the hexBox */
			/* ------------------------------------------ */
			
			byte[] b = ndef.GetBytes();
			DynamicByteProvider p = new DynamicByteProvider(b);
			hexBox.ByteProvider = p;
			
			/* Try to recognize the NDEF, to display it in a user-friendly control */
			/* ------------------------------------------------------------------- */
			
			RtdControl control = null;

			if (ndef is RtdSmartPoster)
			{
				lbDecodedType.Text = "SmartPoster";
				control = new RtdSmartPosterControl();
				control.SetContent(ndef);
				
			} else
				if (ndef is RtdUri)
			{
				lbDecodedType.Text = "URI";
				control = new RtdUriControl();
				control.SetContent(ndef);
				
			} else
				if (ndef is RtdText)
			{
				lbDecodedType.Text = "Text";
				control = new RtdControl();
				control.SetContent(ndef);
				
			} else
				if (ndef is RtdVCard)
			{
				lbDecodedType.Text = "VCard";
				control = new RtdVCardControl();
				control.SetContent(ndef);

			} else
				if (ndef is RtdMedia)
			{
				lbDecodedType.Text = "Media (MIME)";
				control = new RtdMediaControl();
				control.SetContent(ndef);
			}
			
			if (control != null)
			{
				control.Dock = DockStyle.Fill;
				pDecoded.Controls.Add(control);
			}
		}
		
		void BtnCloseClick(object sender, EventArgs e)
		{
			Close();
		}
	}
}
