﻿/*
 * Created by SharpDevelop.
 * User: johann
 * Date: 11/10/2013
 * Time: 13:52
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using SpringCardPCSC;
using SpringCardNFC;

namespace BeamUrl
{
	class Program
	{
		public static Ndef CreateNdef()
		{
			Console.WriteLine("The NDEF message is ready");
			Rtd record = new RtdUri("http://www.springcard.com");
			return record;
		}
		
		public static void NdefSent()
		{
			Console.WriteLine("The NDEF message has been sent");
		}
		
		public static void AdapterError()
		{
			Console.WriteLine("Fatal error (reader removed?)");
			Environment.Exit(1);
		}
		
		public static void Main(string[] args)
		{
			string[] readers = SCARD.GetReaderList();
			SCardNfcAdapter nfcAdapter = null;
				
			if (readers != null)
			{
				for (int i=0; i<readers.Length; i++)
				{
					if (readers[i].Contains("SpringCard"))
					{
						if (readers[i].Contains("NFC") || readers[i].Contains("Contactless"))
						{
							Console.WriteLine("Creating a NFC Sender (SNEP client) on " + readers[i]);
							
							nfcAdapter = new SCardNfcAdapter(readers[i]);
							nfcAdapter.EnableNdefSend(CreateNdef, NdefSent);
							nfcAdapter.Start(AdapterError);
						}						
					}
				}
			}
			
			if (nfcAdapter == null)
				Console.WriteLine("No suitable reader found");
			
			Console.WriteLine("Hit any key to exit");
			Console.ReadKey(true);
			
			if (nfcAdapter != null)
				nfcAdapter.Stop();
		}
	}
}