#ifndef __NFC_CARD_I_H__
#define __NFC_CARD_I_H__

#define NFC_FORUM_MAGIC_NUMBER   0xE1
#define NFC_FORUM_VERSION_NUMBER 0x10

struct _nfc_card_st
{
  SCARDCONTEXT hContext;
	SCARDHANDLE hCard;
  const char *reader;
  int type;
	unsigned long protocol;
  unsigned char atr[32];
	size_t atrlen;

	size_t capacity;

	unsigned short file_id;
	unsigned short max_le;
	unsigned short max_lc;

  BOOL prepared;
	BOOL writable;
	BOOL empty;
};

BOOL nfc_card_transmit(nfc_card_t card, unsigned char capdu[], unsigned long capdu_length, unsigned char rapdu[], unsigned long *rapdu_length);
BOOL nfc_card_read_memory(nfc_card_t card, unsigned short address, unsigned char buffer[], unsigned char length);
BOOL nfc_card_write_memory(nfc_card_t card, unsigned short address, unsigned char buffer[], unsigned char length);
BOOL nfc_card_select_nfc_application(nfc_card_t card);
BOOL nfc_card_select_file(nfc_card_t card, unsigned short file_id);
BOOL nfc_card_read_binary(nfc_card_t card, unsigned short offset, unsigned char buffer[], unsigned char length);
BOOL nfc_card_update_binary(nfc_card_t card, unsigned short offset, unsigned char buffer[], unsigned char length);

BOOL nfc_card_topaz_recognize(nfc_card_t card);
BOOL nfc_card_topaz_prepare(nfc_card_t card);
BOOL nfc_card_topaz_write_content(nfc_card_t card, unsigned char *content, size_t content_length);
BOOL nfc_card_topaz_lock(nfc_card_t card);
BOOL nfc_card_ultralight_recognize(nfc_card_t card);
BOOL nfc_card_ultralight_prepare(nfc_card_t card);
BOOL nfc_card_ultralight_write_content(nfc_card_t card, unsigned char *content, size_t content_length);
BOOL nfc_card_ultralight_lock(nfc_card_t card);
BOOL nfc_card_mifare_prepare(nfc_card_t card);
BOOL nfc_card_mifare_write_content(nfc_card_t card, unsigned char *content, size_t content_length);
BOOL nfc_card_mifare_lock(nfc_card_t card);
BOOL nfc_card_desfire_recognize(nfc_card_t card);
BOOL nfc_card_desfire_prepare(nfc_card_t card);
BOOL nfc_card_desfire_write_content(nfc_card_t card, unsigned char *content, size_t content_length);
BOOL nfc_card_desfire_lock(nfc_card_t card);

#endif
