#ifndef __NFC_NDEF_H__
#define __NFC_NDEF_H__

#define NDEF_HEADER_MESSAGE_BEGIN     0x80
#define NDEF_HEADER_MESSAGE_END       0x40
#define NDEF_HEADER_CHUNK_FLAG        0x20
#define NDEF_HEADER_SHORT_RECORD      0x10
#define NDEF_HEADER_ID_LENGTH_PRESENT 0x08
#define NDEF_HEADER_TNF_MASK          0x07
#define NDEF_HEADER_TNF_EMPTY         0x00
#define NDEF_HEADER_TNF_NFC_RTD_WKN   0x01
#define NDEF_HEADER_TNF_MEDIA_TYPE    0x02
#define NDEF_HEADER_TNF_ABSOLUTE_URI  0x03
#define NDEF_HEADER_TNF_NFC_RTD_EXT   0x04
#define NDEF_HEADER_TNF_UNKNOWN       0x05
#define NDEF_HEADER_TNF_UNCHANGED     0x06
#define NDEF_HEADER_TNF_RESERVED      0x07

typedef struct
{
  unsigned char header;
  size_t type_length;
  size_t id_length;
  size_t payload_length;
  char *type;
  char *id;
  unsigned char *payload;
} _ndef_t;

BOOL ndef_parse_tag(nfc_tag_t tag, unsigned char *ndef_buffer, size_t ndef_size);
BOOL ndef_assemble_tag_alloc(nfc_tag_t tag, unsigned char **ndef_buffer, size_t *ndef_size);

#endif
