﻿/*
 * Created by SharpDevelop.
 * User: jerome.i
 * Date: 24/06/2013
 * Time: 12:07
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using SpringCardMemoryCard;
using SpringCardPCSC;
using SpringCardApplication;

namespace MemoryCardTool
{
	/// <summary>
	/// Description of ChangeSectorTrailer.
	/// </summary>
	public partial class ChangeSectorTrailer : Form
	{
		MifareSector sector;
		Settings settings;
		
		public ChangeSectorTrailer(Settings _settings, MifareSector _sector)
		{			
			InitializeComponent();
			settings = _settings;
			sector = _sector;
			if (sector.Sector > 31)
			{
				lbBlock0.Text = "Blocks 0 - 4";
				lbBlock1.Text = "Blocks 5 - 9";
				lbBlock2.Text = "Blocks 10 - 14";
			}
			
			ShowAccessBits();

			string[] lastKeyAs = settings.LastKeyAs();
			for (int i = 0; i < lastKeyAs.Length ; i++)
				cbKeyA.Items.Add(lastKeyAs[i]);		
			
			if (cbKeyA.Items.Count > 0)
				cbKeyA.SelectedIndex = 0;
			
			string[] lastKeyBs = settings.LastKeyBs();
			for (int i = 0; i < lastKeyBs.Length ; i++)
				cbKeyB.Items.Add(lastKeyBs[i]);		
			
			if (cbKeyB.Items.Count > 0)
				cbKeyB.SelectedIndex = 0;
			
		}
		
		
		void ShowAccessBits()
		{
			byte[] accessBits = sector.AccessBits;
			byte b6, b7, b8, c10, c20, c30, c11, c21, c31, c12, c22, c32, c13, c23, c33;
			string b0="", b1="", b2="", bst="";
			//byte c10p, c20p, c30p, c11p, c21p, c31p, c12p, c22p, c32p, c13p, c23p, c33p;
			
			if (accessBits != null)
			{
				if (accessBits.Length == 4)
				{
					b6 = accessBits[0];
					b7 = accessBits[1];
					b8 = accessBits[2];
					
					c10 = (byte) ((b7 & 0x10) >> 4);			
					c20 = (byte) (b8 & 0x01);					
					c30 = (byte) ((b8 & 0x10) >> 4);
					
					c11 = (byte) ((b7 & 0x20) >> 5);
					c21 = (byte) ((b8 & 0x02) >> 1);
					c31 = (byte) ((b8 & 0x20) >> 5);
					
					c12 = (byte) ((b7 & 0x40) >> 6);
					c22 = (byte) ((b8 & 0x04) >> 2);
					c32 = (byte) ((b8 & 0x40) >> 6);
					
					c13 = (byte) ((b7 & 0x80) >> 7);
					c23 = (byte) ((b8 & 0x08) >> 3);
					c33 = (byte) ((b8 & 0x80) >> 7);
					
					/*---------------------------------
					
					c10p = (byte) (b6 & 0x01);
					c20p = (byte) ((b6 & 0x10) >> 4);
					c30p = (byte) (b7 & 0x01);
					
					c11p = (byte) ((b6 & 0x02) >> 1);
					c21p = (byte) ((b6 & 0x20) >> 5);
					c31p = (byte) ((b7 & 0x02) >> 1);
					
					c12p = (byte) ((b6 & 0x04) >> 2);
					c22p = (byte) ((b6 & 0x40) >> 6);
					c32p = (byte) ((b7 & 0x04) >> 2);
					
					c13p = (byte) ((b6 & 0x08) >> 3);
					c23p = (byte) ((b6 & 0x80) >> 7);
					c33p = (byte) ((b7 & 0x08) >> 3);
					
					string s="";
					s += "C10: " + String.Format("{0:x02}", c10) + " - " + String.Format("{0:x02}", c10p) + "\n";
					s += "C20: " + String.Format("{0:x02}", c20) + " - " + String.Format("{0:x02}", c20p) + "\n";
					s += "C30: " + String.Format("{0:x02}", c30) + " - " + String.Format("{0:x02}", c30p) + "\n";
					s += "C11: " + String.Format("{0:x02}", c11) + " - " + String.Format("{0:x02}", c11p) + "\n";
					s += "C21: " + String.Format("{0:x02}", c21) + " - " + String.Format("{0:x02}", c21p) + "\n";
					s += "C31: " + String.Format("{0:x02}", c31) + " - " + String.Format("{0:x02}", c31p) + "\n";
					s += "C12: " + String.Format("{0:x02}", c12) + " - " + String.Format("{0:x02}", c12p) + "\n";
					s += "C22: " + String.Format("{0:x02}", c22) + " - " + String.Format("{0:x02}", c22p) + "\n";
					s += "C32: " + String.Format("{0:x02}", c32) + " - " + String.Format("{0:x02}", c32p) + "\n";
					s += "C13: " + String.Format("{0:x02}", c13) + " - " + String.Format("{0:x02}", c13p) + "\n";
					s += "C23: " + String.Format("{0:x02}", c23) + " - " + String.Format("{0:x02}", c23p) + "\n";
					s += "C33: " + String.Format("{0:x02}", c33) + " - " + String.Format("{0:x02}", c33p) + "\n";
					MessageBox.Show(s);
					---------------------------------*/
					
					/* Access bits for block 0	*/
					if (c10 == 0x01)
					{
						b0 += "1";
					} else
					{
						b0 += "0";
					}
					
					if (c20 == 0x01)
					{
						b0 += "1";
					}	else
					{
						b0 += "0";
					}
					
					if (c30 == 0x01)
					{
						b0 += "1";
					}	else
					{
						b0 += "0";
					}
					cbBlock0.Text = b0;

					/* Access bits for block 1	*/
					if (c11 == 0x01)
					{
						b1 += "1";
					} else
					{
						b1 += "0";
					}
					
					if (c21 == 0x01)
					{
						b1 += "1";
					}	else
					{
						b1 += "0";
					}
					
					if (c31 == 0x01)
					{
						b1 += "1";
					}	else
					{
						b1 += "0";
					}					
					cbBlock1.Text = b1;
	
					/* Access bits for block 2	*/
					if (c12 == 0x01)
					{
						b2 += "1";
					} else
					{
						b2 += "0";
					}
					
					if (c22 == 0x01)
					{
						b2 += "1";
					}	else
					{
						b2 += "0";
					}
					
					if (c32 == 0x01)
					{
						b2 += "1";
					}	else
					{
						b2 += "0";
					}					
					cbBlock2.Text = b2;
					
					/* Access bits for sector trailer	*/
					if (c13 == 0x01)
					{
						bst += "1";
					} else
					{
						bst += "0";
					}
					
					if (c23 == 0x01)
					{
						bst += "1";
					}	else
					{
						bst += "0";
					}
					
					if (c33 == 0x01)
					{
						bst += "1";
					}	else
					{
						bst += "0";
					}	
					cbSectorTrailer.Text = bst;

				}
				
			}
			
		}
		
		byte[] ComputeAccesBits()
		{
			string b0 = cbBlock0.Text;
			string b1 = cbBlock1.Text;
			string b2 = cbBlock2.Text;
			string bst = cbSectorTrailer.Text;
			byte[] access_bits = new byte[4];
			
			byte c10=0, c20=0, c30=0, c11=0, c21=0, c31=0, c12=0, c22=0, c32=0, c13=0, c23=0, c33=0;
			byte c10p=0, c20p=0, c30p=0, c11p=0, c21p=0, c31p=0, c12p=0, c22p=0, c32p=0, c13p=0, c23p=0, c33p=0;
			byte b6, b7, b8, b9 = 0;
			
			if (b0[0].Equals('1'))
				c10 = 1;
			if (b0[1].Equals('1'))
				c20 = 1;
			if (b0[2].Equals('1'))
				c30 = 1;

			if (b1[0].Equals('1'))
				c11 = 1;
			if (b1[1].Equals('1'))
				c21 = 1;
			if (b1[2].Equals('1'))
				c31 = 1;

			if (b2[0].Equals('1'))
				c12 = 1;
			if (b2[1].Equals('1'))
				c22 = 1;
			if (b2[2].Equals('1'))
				c32 = 1;

			if (bst[0].Equals('1'))
				c13 = 1;
			if (bst[1].Equals('1'))
				c23 = 1;
			if (bst[2].Equals('1'))
				c33 = 1;			
			
			if (c10 == 0)
				c10p = 1;
			if (c20 == 0)
				c20p = 1;
			if (c30 == 0)
				c30p = 1;
			if (c11 == 0)
				c11p = 1;
			if (c21 == 0)
				c21p = 1;
			if (c31 == 0)
				c31p = 1;
			if (c12 == 0)
				c12p = 1;
			if (c22 == 0)
				c22p = 1;
			if (c32 == 0)
				c32p = 1;
			if (c13 == 0)
				c13p = 1;
			if (c23 == 0)
				c23p = 1;
			if (c33 == 0)
				c33p = 1;
	
			/*
			string s = "";
			s+= "C10 = " + String.Format("{0:x02}", c10) + " - C10p = " + String.Format("{0:x02}", c10p) + "\n";
			s+= "C20 = " + String.Format("{0:x02}", c20) + " - C20p = " + String.Format("{0:x02}", c20p) + "\n";
			s+= "C30 = " + String.Format("{0:x02}", c30) + " - C30p = " + String.Format("{0:x02}", c30p) + "\n";
			s+= "C11 = " + String.Format("{0:x02}", c11) + " - C11p = " + String.Format("{0:x02}", c11p) + "\n";
			s+= "C21 = " + String.Format("{0:x02}", c21) + " - C21p = " + String.Format("{0:x02}", c21p) + "\n";
			s+= "C31 = " + String.Format("{0:x02}", c31) + " - C31p = " + String.Format("{0:x02}", c31p) + "\n";
			s+= "C12 = " + String.Format("{0:x02}", c12) + " - C12p = " + String.Format("{0:x02}", c12p) + "\n";
			s+= "C22 = " + String.Format("{0:x02}", c22) + " - C22p = " + String.Format("{0:x02}", c22p) + "\n";
			s+= "C32 = " + String.Format("{0:x02}", c32) + " - C32p = " + String.Format("{0:x02}", c32p) + "\n";
			s+= "C13 = " + String.Format("{0:x02}", c13) + " - C13p = " + String.Format("{0:x02}", c13p) + "\n";
			s+= "C23 = " + String.Format("{0:x02}", c23) + " - C23p = " + String.Format("{0:x02}", c23p) + "\n";
			s+= "C33 = " + String.Format("{0:x02}", c33) + " - C33p = " + String.Format("{0:x02}", c33p) + "\n";	
			MessageBox.Show(s);
			*/
			
			b6 = (byte) ((c23p << 7) + (c22p << 6) + (c21p << 5) + (c20p << 4) + (c13p << 3) + (c12p << 2) + (c11p << 1) + c10p);
			b7 = (byte) ((c13 << 7) + (c12 << 6) + (c11 << 5) + (c10 << 4) + (c33p << 3) + (c32p << 2) + (c31p << 1) + c30p);
			b8 = (byte) ((c33 << 7) + (c32 << 6) + (c31 << 5) + (c30 << 4) + (c23 << 3) + (c22 << 2) + (c21 << 1) + c20);
			if (sector.AccessBits != null)
				if (sector.AccessBits.Length == 4)
					b9 = sector.AccessBits[3];
			
			/*
			s = String.Format("{0:x02}", b6) + " " +String.Format("{0:x02}", b7) + " " +String.Format("{0:x02}", b8) + " " +String.Format("{0:x02}", b9);
			MessageBox.Show(s);
			*/
			
			access_bits[0] = b6;
			access_bits[1] = b7;
			access_bits[2] = b8;
			access_bits[3] = b9;
			
			return access_bits;
			
		}
		
		void BtOkClick(object sender, System.EventArgs e)
		{
			byte[] AccessBits;
			byte[] SectorTrailer;
			byte[] KeyA;
			byte[] KeyB;
			CardBuffer cardbufA;
			CardBuffer cardbufB;
			
			//if (!MifareSector.checkCorrectFormat(mkTxtKeyA.Text.Replace(" ", ""), 6))
			if (!MifareSector.checkCorrectFormat(cbKeyA.Text, 6))
			{
				MessageBox.Show("Key A is incorrect (6 hexadecimal bytes awaited)", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				this.DialogResult = DialogResult.None;
				return;
			}
			
			//if (!MifareSector.checkCorrectFormat(mkTxtKeyB.Text.Replace(" ", ""), 6))
			if (!MifareSector.checkCorrectFormat(cbKeyB.Text, 6))
			{
				MessageBox.Show("Key B is incorrect (6 hexadecimal bytes awaited)", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				this.DialogResult = DialogResult.None;
				return;
			}
			
			AccessBits = ComputeAccesBits();
			
			if (AccessBits == null)
			{
				MessageBox.Show("There is a problem with the calculation of the access bits", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				this.DialogResult = DialogResult.None;
				return;				
			}
			
			if (AccessBits.Length != 4)
			{
				MessageBox.Show("There is a problem with the calculation of the access bits", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				this.DialogResult = DialogResult.None;
				return;						
			}
			
			SectorTrailer = new byte[16];
			
			cardbufA = new CardBuffer(cbKeyA.Text);
			cardbufB = new CardBuffer(cbKeyB.Text);   
			KeyA = cardbufA.GetBytes();
			KeyB = cardbufB.GetBytes();
			
			Array.ConstrainedCopy(KeyA, 0, SectorTrailer, 0, KeyA.Length);
			Array.ConstrainedCopy(AccessBits, 0, SectorTrailer, KeyA.Length, AccessBits.Length);
			Array.ConstrainedCopy(KeyB, 0, SectorTrailer, KeyA.Length + AccessBits.Length, KeyB.Length);
			
			// Save keyA and keyB
			settings.RememberKeyA(cbKeyA.Text);
			settings.RememberKeyB(cbKeyB.Text);
			
			if (!sector.SetSectorTrailer(SectorTrailer))
			{
				MessageBox.Show("There is a problem with the calculation of the sector trailer", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				this.DialogResult = DialogResult.None;		
			}

		}
		
		void CbKeyAKeyDown(object sender, KeyEventArgs e)
		{

		}
	}
}
