﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SpringCard.LibCs
{
	class Binconvert
	{	
		public static byte[] StringToByteArray(string str)
		{
	    char[] s_chars = str.ToCharArray();
	    byte[] s_bytes = new byte[s_chars.Length];
	    for (int i=0; i<s_chars.Length; i++)
	        s_bytes[i] = (byte) s_chars[i];
	    return s_bytes;
		}
		
		public static string ByteArrayToString(byte[] val)
		{
			string s = "";
			for (int i=0; i<val.Length; i++)
			{
				if (val[i] == 0) break;
				s = s + (char) val[i];
			}
			return s;
		}
		
		public static string ToHex(byte[] val)
		{
			string s = "";
			for (int i=0; i<val.Length; i++)
				s += String.Format("{0:X2}", val[i]);
			return s;
		}

		public static string ToHex(byte[] val, int length)
		{
			string s = "";
			for (int i=0; (i<val.Length) && (i<length); i++)
				s += String.Format("{0:X2}", val[i]);
			return s;
		}
		
		public static string ToHex(byte[] val, int offset, int length)
		{
			string s = "";			
			for (int l=0, i=offset; (i<val.Length) && (l<length); i++)
				s += String.Format("{0:X2}", val[i]);
			return s;
		}
		
		public static string ToHex(byte val)
		{
			string s = "";
			s += String.Format("{0:X2}", val);
			return s;
		}		
		
		public static string ToHex(uint val)
		{
			string s = "";
			s += String.Format("{0:X8}", val);
			return s;
		}
		
		public static uint ParseHexDW(string hex)
		{
			byte[] b = HexToBytes(hex);
			uint r = 0;
			
			if (b != null)
			{
				for (int i=0; (i<b.Length) && (i<4); i++)
				{
					r <<= 8;
					r += b[i];
				}
			}
			
			return r;
		}
		
		public static byte[] ParseHex(string hex)
		{
			return HexToBytes(hex);
		}

	    public static byte[] HexToBytes(string hex)
	    {
	        int offset = hex.StartsWith("0x") ? 2 : 0;
	        if ((hex.Length % 2) != 0)
						throw new ArgumentException("Invalid length: " + hex.Length);
	
	        byte[] ret = new byte[(hex.Length-offset)/2];
	
	        for (int i=0; i < ret.Length; i++)
	        {
	            ret[i] = (byte) ((ParseNibble(hex[offset]) << 4) 
	                             | ParseNibble(hex[offset+1]));
	            offset += 2;
	        }
	        return ret;
	    }        

	    public static byte HexToByte(string hex)
	    {
	    	byte[] r = ParseHex(hex);
	    	if ((r == null) || (r.Length == 0))
	    		throw new ArgumentException("Invalid hex byte: " + hex);

	    	return r[0];
	    }        

	    public static bool IsHex(char c)
	    {
        if (c >= '0' && c <= '9')
        {
        	return true;
        }
        if (c >= 'A' && c <= 'F')
        {
         	return true;
        }
        if (c >= 'a' && c <= 'f')
        {
          return true;
        }
        return false;
	    }
	    
	    static int ParseNibble(char c)
	    {
	      if (c >= '0' && c <= '9')
	      {
	      	return c-'0';
	      }
	      if (c >= 'A' && c <= 'F')
	      {
	        return c-'A'+10;
	      }
	      if (c >= 'a' && c <= 'f')
	      {
	        return c-'a'+10;
	      }
	      throw new ArgumentException("Invalid hex digit: " + c);
	    }
	    
	    
	    static bool is_number(char c)
			{
			  if ((c >= '0') && (c <= '9'))
			  {
			    return true;
			  } else
			  {
			    return false;
			  }
			
			}
				
		static byte hex_to_byte(char c)
		{
			if ((c >= '0') && (c <= '9')) return (byte) (c - '0');
			if ((c >= 'A') && (c <= 'F')) return (byte) (c - 'A' + 10);
			if ((c >= 'a') && (c <= 'f')) return (byte) (c - 'a' + 10);
			return 0xFF;
		}
	    	
		public static  byte[]  DecimalASCII_to_BYTEArray(string ascii_number)
		{
		  UInt64 number = 0, result = 0;
		  int i=0, offset = 0 ;
		  byte[] tmp = new byte[255];
		
		  for (i=0; i<ascii_number.Length - 1; i++)
		  {
		    if (is_number(ascii_number[i]))
		    {
		      number += hex_to_byte(ascii_number[i]);
		      number *= 10;
		    }  else
		    {
		      return null;
		    }
		  }
		  number += hex_to_byte(ascii_number[ascii_number.Length-1]);
		
		  while(true)
		  {
		    result = number / 256;
		    if ( result > 0)
		    {
		      if (offset < 255)
		      {
		        tmp[offset++] = (byte) (number - (result * 256));
		        number = result;
		      } else
		      {
		        return null;
		      }
		
		    } else
		    {
		      if (offset < 255)
		      {
		        tmp[offset++] = (byte) number;
		        break;
		      } else
		      {
		        return null;
		      }
		    }
		  }
		  byte[] res_bytes = new byte[offset];
		  for (i=0; i<offset ; i++)
		    res_bytes[offset - 1 - i] = tmp[i];
		
		  return res_bytes;
		
		}
	
	}
		
}
