using System;
using System.Drawing;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Text;
using System.Diagnostics;
using Microsoft.Win32;

namespace SpringCard.LibCs
{
  class SystemConsole
  {
    [DllImport("kernel32.dll", SetLastError = true)]
    public static extern bool AllocConsole();

    [DllImport("kernel32.dll", SetLastError = true)]
    public static extern bool FreeConsole();

    [DllImport("kernel32", SetLastError = true)]
    public static extern bool AttachConsole(int dwProcessId);

    [DllImport("user32.dll")]
    public static extern IntPtr GetForegroundWindow();

    [DllImport("user32.dll", SetLastError = true)]
    public static extern uint GetWindowThreadProcessId(IntPtr hWnd, out int lpdwProcessId);
    
    private static bool Visible = false;
    
    public static void Show()
    {
      if (!Visible)
      {      
        IntPtr ptr = GetForegroundWindow();
        int  u;
        GetWindowThreadProcessId(ptr, out u);
        Process process = Process.GetProcessById(u);
        if (process.ProcessName.Equals("cmd"))    //Is the uppermost window a cmd process?
        {
          AttachConsole(process.Id);
          Console.WriteLine("\n" + Application.ProductName + " v."+Application.ProductVersion+"\n");
        }
        else
        {
          AllocConsole();       
          Console.WriteLine("\n" + Application.ProductName + " v."+Application.ProductVersion+"\n");
        }
        Visible = true;
      }
    }
    
    public static void Hide()
    {
      if (Visible)
        FreeConsole();
      Visible = false;
    }
  }  
}
