import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;


import javax.smartcardio.*;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.SwingUtilities;

public class JpcscApplet extends JApplet{

	/**
	 */
	private static final long serialVersionUID = 1L;
	JButton butTransmit = new JButton("Transmit");
	JButton butRefresh = new JButton("Refresh");
	JButton butConnect = new JButton("Connect");
	JButton butDisconnect = new JButton("Disconnect");
	JRadioButton T1Protocol = new JRadioButton("T=1",false);
	JRadioButton T0Protocol = new JRadioButton("T=0",false);
	JRadioButton AnyProtocol = new JRadioButton("Any",true);
	JCheckBox Reset = new JCheckBox("Reset",false);
	String Protocol = "*"; 
	JTextField ApduIn;
	JComboBox ReaderList;
	JTextField ApduOut;
	Container Panel;
	LayoutManager Layout;
	CardTerminal WorkingReader;
	JLabel Info;
	Card card;
	boolean resetWhenDisconnect = false;
	Thread cardPresentThread = null;
	CardInReader cir;
	Notify CardPresentNotify = new Notify(){
        @Override public void doneIt() {
            SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                	CardPresent();
                }
            });
        }
    };
    Thread cardAbsentThread = null;
   CardRemoved cr;
	Notify CardAbsentNotify = new Notify(){
        @Override public void doneIt() {
            SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                	CardAbsent();
                }
            });
        }
    };
   // Thread cardStatusThread = null;
  //  CardStatus cs;
	
	public void stop()
	{
		KillThread();
	}


	/**
	 * Mthode d'initialisation de l'applet
	 * C'est cette mthode qui fait office de constructeur
	 */
	public void init(){
		this.setSize(450, 200);

	    ReaderList = new JComboBox();
	    Layout = new FlowLayout ();
	    Panel = getContentPane ();
	    Info = new JLabel();
	    
	   /* cs = new CardStatus();
		cs.AddNotifyCardAbsent(CardAbsentNotify);
		cs.AddNotifyCardPresent(CardPresentNotify);
		cardStatusThread = new Thread(cs);
		cardStatusThread.start();*/
				
		//adding click function to the button
		butTransmit.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				TransmitApduToCard();
			}			
		});
		
		butRefresh.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				FillComboBox();
			}			
		});
		

		
		butConnect.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				Info.setText("Dbut du travail");
				try {
					Info.setText("j'essaye de me connecter");
					card = WorkingReader.connect(Protocol);
					Info.setText("j'ai essay de me connecter");
					if(card != null)
					{
						Info.setText("youpi! je suis connect");
						butTransmit.setEnabled(true);
						butDisconnect.setEnabled(true);
						Reset.setEnabled(true);
						butConnect.setEnabled(false);
					    T1Protocol.setEnabled(false);
					    T0Protocol.setEnabled(false);
					    AnyProtocol.setEnabled(false);
					}
					Info.setText("j'ai fini de travailler");
				} catch (CardException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					Info.setText("Connect failed. Try using another protocol");
				}
			}			
		});
		
		butDisconnect.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				try {
					card.disconnect(resetWhenDisconnect);
					butTransmit.setEnabled(false);
					butConnect.setEnabled(true);
				    T1Protocol.setEnabled(true);
				    T0Protocol.setEnabled(true);
				    AnyProtocol.setEnabled(true);
				    CardAbsent();
				} catch (CardException e) {
					// TODO Auto-generated catch block
					Info.setText("Disconnect failed.");
					e.printStackTrace();
				}
			}			
		});
		
		T1Protocol.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				/* uncheck other radio buttons */
				AnyProtocol.setSelected(false);
				T0Protocol.setSelected(false);
				/* set new protocol */
				Protocol = "T=1";
			}			
		});
		
		T0Protocol.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				/* uncheck other radio buttons */
				AnyProtocol.setSelected(false);
				T1Protocol.setSelected(false);
				/* set new protocol */
				Protocol = "T=0";
			}			
		});
		
		Reset.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e) {
				resetWhenDisconnect = ((e.getStateChange() == ItemEvent.SELECTED));
			}
				
		});
		
		AnyProtocol.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				/* uncheck other radio buttons */
				T1Protocol.setSelected(false);
				T0Protocol.setSelected(false);
				/* set new protocol */
				Protocol = "*";
			}			
		});
	    
		ReaderList.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e) {
				if(ReaderList.getSelectedItem() != null)
				{
					WorkingReader = (CardTerminal) ReaderList.getSelectedItem();
					Info.setText("Selected Reader : "+WorkingReader.getName());
					System.out.println("Setting reader");
					//cs.setReader(WorkingReader);
					try {
						if(WorkingReader.isCardPresent())
							CardPresent();
						else
								CardAbsent();
					} catch (CardException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
				}
			}			
		});
		

		ApduIn = new JTextField ("", 40);
	    ApduOut = new JTextField ("", 40);

	    ApduOut.setEditable (false);
	    butTransmit.setEnabled(false);
	    butConnect.setEnabled(false);
	    T1Protocol.setEnabled(false);
	    T0Protocol.setEnabled(false);
	    AnyProtocol.setEnabled(false);
	    butDisconnect.setEnabled(false);
	    Reset.setEnabled(false);
	    ApduOut.setBackground (Color.lightGray);
	    ReaderList.setEditable(false);
	    Panel.setLayout (Layout);
	    Panel.add(ReaderList);
	    Panel.add(butRefresh);
	    Panel.add(butConnect);
	    Panel.add(T1Protocol);
	    Panel.add(T0Protocol);
	    Panel.add(AnyProtocol);
	    Panel.add(butDisconnect);
	    Panel.add(Reset);
	    Panel.add (ApduIn);
	    Panel.add(butTransmit);
	    Panel.add (ApduOut);
		Info.setHorizontalAlignment(JLabel.CENTER);
		Info.setForeground(Color.blue);
        Panel.add(Info);
	    FillComboBox();

	}
	
	public void KillThread()
	{
		if(cardPresentThread != null && cardPresentThread.isAlive())
		{
			cir.removeNotifyListener(CardPresentNotify);
			Thread moribund = cardPresentThread;
	        cardPresentThread = null;
	        moribund.interrupt();
		}
		if(cardAbsentThread != null && cardAbsentThread.isAlive())
		{
			cr.removeNotifyListener(CardAbsentNotify);
			Thread moribund = cardAbsentThread;
	        cardAbsentThread = null;
	        moribund.interrupt();
		}/*
		if(cardStatusThread != null && cardStatusThread.isAlive())
		{
			cs.removeNotifyAbsent(CardAbsentNotify);
			cs.removeNotifyPresent(CardPresentNotify);
			Thread moribund = cardStatusThread;
	        cardStatusThread = null;
	        moribund.interrupt();
		}*/
	}

	public void FillComboBox()
	{
		/* We fill the comboBox component with the list of the PC/SC readers found */
		CardTerminals terminalList;
		CardTerminal toSelect = WorkingReader;
		TerminalFactory factory = TerminalFactory.getDefault();
	    terminalList = factory.terminals();
	    ReaderList.removeAllItems();
	    try {
	    	for (int i=0;  i < terminalList.list().size(); i++)
			{
			    //System.out.println("Reader " + i + ": " + terminalList.list().get(i).getName());
               ReaderList.addItem(terminalList.list().get(i)) ; 
			 }
			if(toSelect != null)
				ReaderList.setSelectedItem(toSelect);
 
		} catch (CardException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void CardPresent()
	{
		Info.setText(WorkingReader+" : Card Present");
		butConnect.setEnabled(true);
	    T1Protocol.setEnabled(true);
	    T0Protocol.setEnabled(true);
	    AnyProtocol.setEnabled(true);	
	    KillThread();
	    try {
			cr = new CardRemoved(WorkingReader);
			cr.addNotifyListener(CardAbsentNotify);
			cardAbsentThread = new Thread(cr);
			cardAbsentThread.start();
	    	//cs.NotifyCardAbsent();
			
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	 }
	
	public void CardAbsent()
	{
		Info.setText(WorkingReader+" : No Card on the reader");
		butConnect.setEnabled(false);
	    T1Protocol.setEnabled(false);
	    T0Protocol.setEnabled(false);
	    AnyProtocol.setEnabled(false);
	    butTransmit.setEnabled(false);
	    butDisconnect.setEnabled(false);
	    Reset.setEnabled(false);
		KillThread();
	    try {
			cir = new CardInReader(WorkingReader);
			
			cardPresentThread = new Thread(cir);
			cardPresentThread.start();
			cir.addNotifyListener(CardPresentNotify);
	    	//cs.NotifyCardPresent();
	    	
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}

	
	public void TransmitApduToCard()
	{
		//byte[] GET_DATA = {(byte) 0xFF,(byte) 0xCA,(byte) 0x00,(byte) 0x00,(byte) 0x00};
		//ApduIn.setText("FF CA 00 00 00");
		
		try {
			
		    CardChannel comm = card.getBasicChannel();
		    CommandAPDU getData = new CommandAPDU(hexStringToByteArray(ApduIn.getText()));
		    ResponseAPDU resp = comm.transmit(getData);
		    ApduOut.setText(byteArrayToHexString(resp.getBytes()));

		} catch (CardException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	static String byteArrayToHexString(byte[] bArray){
		  StringBuffer buffer = new StringBuffer();
		    
		  for(byte b : bArray) {
		  
		      buffer.append(String.format(" %02X" , b));
		  }
		    
		  return buffer.toString().toUpperCase();    
		}
	
	public static byte[] hexStringToByteArray(String s) {
		s = s.replace(" ", "");
	    int len = s.length();
	    byte[] data = new byte[len / 2];
	    for (int i = 0; i < len; i += 2) {
	        data[i / 2] = (byte) ((Character.digit(s.charAt(i), 16) << 4)
	                             + Character.digit(s.charAt(i+1), 16));
	    }
	    return data;
	}

	
	
}

