
import java.util.List;

import javax.smartcardio.*;


public class pcscmon {
	
	 
  public static void main(String[] args){
	CardTerminals terminalList;
	List<CardTerminal> terminalCardPresentList;
	List<CardTerminal> oldterminalCardPresentList = null;
    int nbReaders = 0;
    int oldNbReaders = 0;
    int nbReadersCardPresent = 0;
    int oldNbReadersCardPresent = 0;
	boolean bFirstRun = true;
	byte[] GET_DATA = {(byte) 0xFF,(byte) 0xCA,(byte) 0x00,(byte) 0x00,(byte) 0x00};
		
	for(;;)
	{
		try 
	    {
	      // show the list of available terminals
	      TerminalFactory factory = TerminalFactory.getDefault();
	      terminalList = factory.terminals();

	
	      nbReaders = terminalList.list().size();
	      if(bFirstRun)
	      {	  
		    //List Card readers
		    for (int i=0;  i < terminalList.list().size(); i++)
		    {
			    System.out.println("Reader " + i + ": " + terminalList.list().get(i).getName());
			    System.out.println("\tCard State : ");
			    String cardStatus = " No card in the reader";
			    if(terminalList.list().get(i).isCardPresent())
			 	  cardStatus = " Card Present";
			   System.out.println("\t\t"+ cardStatus );
		     }
	      }	else
	      {
	    	  // if the number of readers has changed
	    	  if(nbReaders != oldNbReaders)
	    	  {
	    		int difference;
	    		// reader added
	    		if(nbReaders > oldNbReaders)
	    		{		
	    			difference = nbReaders - oldNbReaders; 
	    			System.out.print(String.format("%d", difference)+" reader");
	    			if(difference>1)
	    				System.out.println("s have been added");
	    			else
	    				System.out.println(" has been added"); 
	    		}
	    		else
	    		// reader removed	
	    		{
	    			difference =  oldNbReaders -nbReaders; 
	    			System.out.print(String.format("%d", difference)+" reader");
	    			if(difference>1)
	    				System.out.println("s have been removed");
	    			else
	    				System.out.println(" has been removed");
	    		}
	    		
	    		//List Card readers
			    for (int i=0;  i < terminalList.list().size(); i++)
			    {
				    System.out.println("Reader " + i + ": " + terminalList.list().get(i).getName());
				    System.out.println("\tCard State : ");
				    String cardStatus = " No card in the reader";
				    if(terminalList.list().get(i).isCardPresent())
				 	  cardStatus = " Card Present";
				   System.out.println("\t\t"+ cardStatus );
			     }
	    	   }
	    	    
	      }
	      
	      
	      /* Now we are trying to find if there has been a change of a card status */
	      terminalCardPresentList = terminalList.list(CardTerminals.State.CARD_INSERTION);
	      nbReadersCardPresent = terminalCardPresentList.size();
	      if (  (oldNbReadersCardPresent != nbReadersCardPresent) )
	      {
	    	  
	    	  // if the number of readers containing a card has changed
	    	  if(nbReadersCardPresent != oldNbReadersCardPresent)
	    	  {
	    		// card inserted
	    		if(nbReadersCardPresent > oldNbReadersCardPresent)
	    		{		
	    		  for (CardTerminal terminal : terminalCardPresentList)
		    	  {
		    		if((oldterminalCardPresentList==null) || !(oldterminalCardPresentList.contains(terminal)) )
		    		{
		    		  System.out.println("Card inserted into "+terminal.getName());
		    		  // establish a connection with the card
		    	      Card card = terminal.connect("*");
		    	      //reset the card
		    	      ATR atr = card.getATR();
		    	      new ATR_Analysis(atr.getBytes(),atr.getBytes().length);
		    	      CardChannel comm = card.getBasicChannel();
		    	      CommandAPDU getData = new CommandAPDU(GET_DATA);
		    	      ResponseAPDU resp = comm.transmit(getData);
		    	      System.out.println("Get Data returned "+byteArrayToHexString(resp.getBytes()));
		    	      card.disconnect(false);
		    		}
		    	  } 
	    		}
	    		else
	    		// card removed	
	    		{
	    		 for (CardTerminal terminal : oldterminalCardPresentList)
	    		 {
	    			if( !(terminalCardPresentList.contains(terminal))) 
	    				System.out.println("Card removed from "+terminal.getName());
	    		 }
	    		}
	    	  }
	      }
	    
	      

	      bFirstRun = false;
	      oldNbReaders = nbReaders;
	      oldNbReadersCardPresent = nbReadersCardPresent;
	      oldterminalCardPresentList = terminalCardPresentList;
	      terminalList.waitForChange(3000);
	    }
	    catch (Exception ex) {
	      System.out.println("Exception : " + ex);
	    }
	}  
	 
  }

  static String byteArrayToHexString(byte[] bArray){
	    StringBuffer buffer = new StringBuffer();
	    
	    for(byte b : bArray) {
	      buffer.append(String.format(" %02X" , b));
	    }
	    
	    return buffer.toString().toUpperCase();    
	  }



}
