#include "quickbatch.h"

BOOL control_select_card_types(smartcard_t card, BOOL iso_14443a, BOOL iso_14443b)
{
  BYTE capdu[] = { 0x58, 0x8D, 0xB0, 0x00, 0x00 };
  BYTE rapdu[256];
  unsigned long rapdu_length = sizeof(rapdu);

  if (iso_14443a)
    capdu[4] |= 0x01;
  if (iso_14443b)
    capdu[4] |= 0x02;

  if (!pcsc_control(card, capdu, sizeof(capdu), rapdu, &rapdu_length))
    return FALSE;

  if (rapdu[0])
  {
    if (be_verbose)
      printf("Reader error -%d (0x%02X) to our control command\n", rapdu[0], rapdu[0]);
    return FALSE;
  }

  return TRUE;
}

